package com.MythiCode.camerakit;

import android.media.ImageReader;
import android.os.Build;

import androidx.annotation.NonNull;
import androidx.annotation.RequiresApi;

import com.google.android.gms.tasks.OnFailureListener;
import com.google.android.gms.tasks.OnSuccessListener;
import com.google.firebase.ml.vision.barcode.FirebaseVisionBarcode;
import com.google.firebase.ml.vision.barcode.FirebaseVisionBarcodeDetector;
import com.google.firebase.ml.vision.common.FirebaseVisionImage;

import java.util.List;

public class BarcodeDetector {

    private static ImageReader imageReader;

    public static void setImageReader(ImageReader imageReader) {
        BarcodeDetector.imageReader = imageReader;
    }

    @RequiresApi(api = Build.VERSION_CODES.KITKAT)
    public static void detectImage(final ImageReader imageReader, FirebaseVisionBarcodeDetector detector, FirebaseVisionImage firebaseVisionImage, final FlutterMethodListener flutterMethodListener){
        detector.detectInImage(firebaseVisionImage)
                .addOnSuccessListener(new OnSuccessListener<List<FirebaseVisionBarcode>>() {
                    @Override
                    public void onSuccess(List<FirebaseVisionBarcode> firebaseVisionBarcodes) {
                        //thread main
                        if (imageReader ==  BarcodeDetector.imageReader) {
                            if (firebaseVisionBarcodes.size() > 0) {
                                for (FirebaseVisionBarcode visionBarcode : firebaseVisionBarcodes) {
                                    flutterMethodListener.onBarcodeRead(visionBarcode.getRawValue());
                                }
                            }
                        }
                    }
                }).addOnFailureListener(new OnFailureListener() {
            @Override
            public void onFailure(@NonNull Exception e) {
                System.out.println("barcode read failed: " + e.getMessage());
            }
        });
    }



}
